diff -pruN 3.5-9/debian/changelog 3.5-9ubuntu1/debian/changelog
--- 3.5-9/debian/changelog	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/changelog	2020-05-20 07:57:39.000000000 +0000
@@ -1,3 +1,41 @@
+chrony (3.5-9ubuntu1) groovy; urgency=medium
+
+  * Merge with Debian unstable (LP: #1878005). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+    - d/t/control: harden time-sources-from-dhcp-servers test for systemd change
+      (LP: 1873031)
+  * Dropped changes [in Debian now]
+    - d/t/upstream-system-tests: stop chrony/systemd-timesynd before tests
+    - d/t/upstream-system-tests: fix stderr in case services do not exist
+    - Stop starting systemd-timesyncd in postrm. This is no longer relevant
+      since systemd-timesyncd is a standalone package declaring
+      Conflicts/Replaces/Provides: time-daemon. (Closes 955773, LP: 1872183)
+    - d/postrm: Reinstate the remove target (LP: 1873810)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 20 May 2020 09:57:39 +0200
+
 chrony (3.5-9) unstable; urgency=medium
 
   * debian/patches/:
@@ -60,6 +98,76 @@ chrony (3.5-7) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Tue, 17 Mar 2020 15:21:53 +0100
 
+chrony (3.5-6ubuntu6) focal; urgency=medium
+
+  * d/postrm: Reinstate the remove target (LP: #1873810)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 20 Apr 2020 15:58:52 +0200
+
+chrony (3.5-6ubuntu5) focal; urgency=medium
+
+  * d/t/control: harden time-sources-from-dhcp-servers test for systemd change
+    (LP: #1873031)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 15 Apr 2020 18:23:10 +0200
+
+chrony (3.5-6ubuntu4) focal; urgency=medium
+
+  * debian/postrm:
+    - Stop starting systemd-timesyncd in postrm. This is no longer relevant
+      since systemd-timesyncd is a standalone package declaring
+      Conflicts/Replaces/Provides: time-daemon. (Closes 955773, LP: #1872183)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 15 Apr 2020 09:01:30 +0200
+
+chrony (3.5-6ubuntu3) focal; urgency=medium
+
+  * avoid multiple time services running concurrently (LP: #1870144).
+    This fixes the autopkgtests vs chrond itself, the issue of concurrent
+    systemd-timesyncd will be fixed in systemd by (LP 1849156)
+    - d/t/upstream-system-tests: stop chrony/systemd-timesynd before tests
+    - d/t/upstream-system-tests: fix stderr in case services do not exist
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 01 Apr 2020 09:25:45 +0200
+
+chrony (3.5-6ubuntu2) focal; urgency=medium
+
+  * fix capsh usage in focal avoiding to always fall back to -x (LP: #1867036)
+    - d/control: add versioned dependency to libcap2-bin new enough to
+      support --has-p
+    - d/chronyd-starter.sh: update capsh usage to use --has-p
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 31 Mar 2020 10:19:20 +0200
+
+chrony (3.5-6ubuntu1) focal; urgency=medium
+
+  * Merge with Debian unstable (LP: #1866753). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 12 Mar 2020 11:02:33 +0100
+
 chrony (3.5-6) unstable; urgency=medium
 
   * debian/chrony.service:
@@ -94,6 +202,41 @@ chrony (3.5-6) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Tue, 10 Mar 2020 19:17:16 +0100
 
+chrony (3.5-5ubuntu1) focal; urgency=medium
+
+  * Merge with Debian unstable (LP: #1859969). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+  * Dropped changes:
+    - d/t/control: destructive_system_tests only work on amd64 and s390x right
+      now [fixed by backporting fixes from upstream in 3.5-5 ]
+    - d/t/upstream-simulation-test-suite: ignore warnings on stderr while
+      running clksim make
+      [ in Debian 3.5-5 ]
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 16 Jan 2020 12:55:32 +0100
+
 chrony (3.5-5) unstable; urgency=medium
 
   * debian/control:
@@ -121,6 +264,47 @@ chrony (3.5-5) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Sun, 22 Dec 2019 17:30:40 +0100
 
+chrony (3.5-4ubuntu2) focal; urgency=medium
+
+  * d/t/control: destructive_system_tests only work on amd64 and s390x right
+    now
+  * d/t/upstream-simulation-test-suite: ignore warnings on stderr while
+    running clksim make
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 03 Dec 2019 14:50:50 +0100
+
+chrony (3.5-4ubuntu1) focal; urgency=medium
+
+  * Merge with Debian unstable (LP: #1854328). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+  * Dropped changes:
+    - d/t/control: allow stderr for recent changes in resolved/iproute
+      (LP 1836882) [no more needed]
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 28 Nov 2019 10:31:36 +0100
+
 chrony (3.5-4) unstable; urgency=medium
 
   * debian/tests/control:
@@ -165,6 +349,52 @@ chrony (3.5-3) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Tue, 13 Aug 2019 17:57:47 +0200
 
+chrony (3.5-2ubuntu3) focal; urgency=medium
+
+  * No-change rebuild against libnettle7
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Oct 2019 22:07:56 +0000
+
+chrony (3.5-2ubuntu2) eoan; urgency=medium
+
+  * d/t/control: allow stderr for recent changes in resolved/iproute
+    (LP: #1836882)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 17 Jul 2019 12:41:58 +0200
+
+chrony (3.5-2ubuntu1) eoan; urgency=medium
+
+  * Merge with Debian experimental (LP: #1835046). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+   * Dropped changes (accepted in Debian now):
+    - d/postrm: re-establish systemd-timesyncd on removal (LP 1764357)
+    - d/postrm: respect policy-rc.d when restoring systemd-timesyncd
+      (LP 1771994)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 02 Jul 2019 13:37:23 +0200
+
 chrony (3.5-2) unstable; urgency=medium
 
   * Merge branch “experimental” into “master”.
@@ -251,6 +481,56 @@ chrony (3.5~pre1-1) experimental; urgenc
 
  -- Vincent Blut <vincent.debian@free.fr>  Sun, 12 May 2019 22:16:14 +0200
 
+chrony (3.4-4ubuntu2) eoan; urgency=medium
+
+  * Dropped sysV change added in 3.4-4ubuntu1 (LP: #1829700):
+    - removed d/init to avoid weird interactions between sysV and systemd
+    [With debhelper compat level 12 this isn't an issue anymore]
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 22 May 2019 09:10:41 +0200
+
+chrony (3.4-4ubuntu1) eoan; urgency=medium
+
+  * Merge with Debian unstable (LP: #1828992). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664 1754358)
+    - Set -x as default if unable to set time (e.g. in containers) (LP 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off) [fixed a minor typo in the comment in this update]
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chrony-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+    - d/postrm: re-establish systemd-timesyncd on removal (LP 1764357)
+    - d/postrm: respect policy-rc.d when restoring systemd-timesyncd
+      (LP 1771994)
+  * Added Changes:
+    - removed d/init to avoid weird interactions between sysV and systemd
+  * Dropped Changes:
+    - Notify chrony to update sources in response to systemd-networkd
+      events (LP: 1718227)
+      + d/links: link dispatcher script to networkd-dispatcher events routable
+        and off
+      + d/control: set Recommends to networkd-dispatcher
+      [Those are in Debian, except that we agreed to have networkd-dispatcher
+       to only be a Suggests]
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 14 May 2019 12:49:30 +0200
+
 chrony (3.4-4) unstable; urgency=medium
 
   * debian/patches/*:
@@ -327,6 +607,48 @@ chrony (3.4-2) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Wed, 13 Feb 2019 17:08:17 +0100
 
+chrony (3.4-1ubuntu1) disco; urgency=medium
+
+  * Merge with Debian unstable (LP: #1802886). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664)
+    - Set -x as default if unable to set time (e.g. in containers) (LP: 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      + debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      + debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      + debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off).
+      + debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      + debian/install: make chronyd-starter.sh available on install.
+      + debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+    - d/postrm: re-establish systemd-timesyncd on removal (LP: 1764357)
+    - Notify chrony to update sources in response to systemd-networkd
+      events (LP: 1718227)
+      + d/links: link dispatcher script to networkd-dispatcher events routable
+        and off
+      + d/control: set Recommends to networkd-dispatcher
+  * Dropped Changes (upstream):
+    - d/p/lp-1718227-nm-dispatcher-for-networkd.patch
+    - d/p/lp-1787366-fall-back-to-urandom.patch: avoid hangs when starting
+      the service on newer kernels by falling back to urandom. (LP: 1787366)
+  * Added Changes:
+    - d/postrm: respect policy-rc.d when restoring systemd-timesyncd
+      (LP: #1771994)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 12 Nov 2018 11:39:08 +0100
+
 chrony (3.4-1) unstable; urgency=medium
 
   * Import upstream version 3.4:
@@ -403,6 +725,66 @@ chrony (3.3-3) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Sat, 18 Aug 2018 16:23:19 +0200
 
+chrony (3.3-2ubuntu2) cosmic; urgency=medium
+
+  * - d/p/lp-1787366-fall-back-to-urandom.patch: avoid hangs when starting
+      the service on newer kernels by falling back to urandom.
+      (LP: #1787366, Closes: #906276)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 16 Aug 2018 11:48:38 +0200
+
+chrony (3.3-2ubuntu1) cosmic; urgency=medium
+
+  * Merge with Debian unstable (LP: #1771061). Remaining changes:
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664)
+    - Set -x as default if unable to set time (e.g. in containers) (LP: 1589780)
+      Chrony is a single service which acts as both NTP client (i.e. syncing the
+      local clock) and NTP server (i.e. providing NTP services to the network),
+      and that is both desired and expected in the vast majority of cases.
+      But in containers syncing the local clock is usually impossible, but this
+      shall not break the providing of NTP services to the network.
+      To some extent this makes chrony's default config more similar to 'ntpd',
+      which complained in syslog but still provided NTP server service in those
+      cases.
+      - debian/chrony.service: allow the service to run without CAP_SYS_TIME
+      - debian/control: add new dependency libcap2-bin for capsh (usually
+        installed anyway, but make them explicit to be sure).
+      - debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+        (Default off).
+      - debian/chronyd-starter.sh: wrapper to handle special cases in containers
+        and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+        containers on a default installation and avoid failing to sync time (or
+        if allowed to sync, avoid multiple containers to fight over it by
+        accident).
+      - debian/install: make chronyd-starter.sh available on install.
+      - debian/docs, debian/README.container: provide documentation about the
+        handling of this case.
+    - d/postrm: re-establish systemd-timesyncd on removal (LP: 1764357)
+    - Notify chrony to update sources in response to systemd-networkd
+      events (LP: 1718227)
+      - d/links: link dispatcher script to networkd-dispatcher events routable
+        and off
+      - d/control: set Recommends to networkd-dispatcher
+      - d/p/lp-1718227-nm-dispatcher-for-networkd.patch
+  * Dropped changes
+    - debian/usr.sbin.chronyd: ensure RTC/GPS usage isn't blocked by apparmor
+      (LP: 1751241) (in Debian now)
+    - debian/usr.sbin.chronyd: add cap net_admin for hwtimestamp (LP: 1761327)
+      (in Debian now)
+    - d/p/lp1589780-sys_linux-don-t-keep-CAP_SYS_TIME-with-x-option.patch:
+      When dropping the root privileges, don't try to keep the CAP_SYS_TIME
+      capability if the -x option was enabled. This allows chronyd to be
+      started without the capability (e.g. in containers) and also drop the
+      root privileges (This is upstream now).
+    - d/p/lp-1718227-ignore-non-up-down-events-in-nm-dispatcher.patch (This is
+      upstream now).
+    - d/control: switch to nss instead of tomcrypt (Debian switched to nettle
+      which is in main, so we can drop this)
+  * Added changes
+    - debian/README.container: fix typos
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 14 May 2018 09:06:01 +0200
+
 chrony (3.3-2) unstable; urgency=medium
 
   * debian/chrony.service:
@@ -458,6 +840,76 @@ chrony (3.2-5) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Wed, 28 Feb 2018 17:31:08 +0100
 
+chrony (3.2-4ubuntu4) bionic; urgency=medium
+
+  * d/postrm: re-establish systemd-timesyncd on removal (LP: #1764357)
+  * Notify chrony to update sources in response to systemd-networkd
+    events (LP: #1718227)
+    - d/links: link dispatcher script to networkd-dispatcher events routable
+      and off
+    - d/control: set Recommends to networkd-dispatcher
+    - d/p/lp-1718227-ignore-non-up-down-events-in-nm-dispatcher.patch
+    - d/p/lp-1718227-nm-dispatcher-for-networkd.patch
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 16 Apr 2018 17:04:06 +0200
+
+chrony (3.2-4ubuntu3) bionic; urgency=medium
+
+  * debian/usr.sbin.chronyd: add cap net_admin for hwtimestamp (LP: #1761327)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 05 Apr 2018 09:38:10 +0200
+
+chrony (3.2-4ubuntu2) bionic; urgency=medium
+
+  * Set -x as default if unable to set time (e.g. in containers) (LP: #1589780)
+    Chrony is a single service which acts as both NTP client (i.e. syncing the
+    local clock) and NTP server (i.e. providing NTP services to the network),
+    and that is both desired and expected in the vast majority of cases.
+    But in containers syncing the local clock is usually impossible, but this
+    shall not break the providing of NTP services to the network.
+    To some extent this makes chrony's default config more similar to 'ntpd',
+    which complained in syslog but still provided NTP server service in those
+    cases.
+    - d/p/lp1589780-sys_linux-don-t-keep-CAP_SYS_TIME-with-x-option.patch:
+      When dropping the root privileges, don't try to keep the CAP_SYS_TIME
+      capability if the -x option was enabled. This allows chronyd to be
+      started without the capability (e.g. in containers) and also drop the
+      root privileges.
+    - debian/chrony.service: allow the service to run without CAP_SYS_TIME
+    - debian/control: add new dependency libcap2-bin for capsh (usually
+      installed anyway, but make them explicit to be sure).
+    - debian/chrony.default: new option SYNC_IN_CONTAINER to not fall back
+      (Default off).
+    - debian/chronyd-starter.sh: wrapper to handle special cases in containers
+      and if CAP_SYS_TIME is missing. Effectively allows to run NTP server in
+      containers on a default installation and avoid failing to sync time (or
+      if allowed to sync, avoid multiple containers to fight over it by
+      accident).
+    - debian/install: make chronyd-starter.sh available on install.
+    - debian/docs, debian/README.container: provide documentation about the
+      handling of this case.
+  * debian/chrony.conf: update default chrony.conf to not violate the policy
+    of pool.ntp.org (to use no more than four of their servers) and to provide
+    more ipv6 capable sources by default (LP: #1754358)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Fri, 16 Mar 2018 12:25:44 +0100
+
+chrony (3.2-4ubuntu1) bionic; urgency=medium
+
+  * Merge with Debian unstable. Remaining changes:
+    - d/control: switch to nss instead of tomcrypt (nss is in main)
+    - d/chrony.conf: use ubuntu ntp pool and server (LP 1744664)
+  * Dropped changes (in Debian)
+    - d/chrony.default, d/chrony.service: support /etc/default/chrony
+      DAEMON_OPTS in systemd environment (LP: 1746081)
+    - d/chrony.service: properly start after networking (LP: 1746458)
+    - d/usr.sbin.chronyd: allow to create /run/chrony on demand (LP: 1746444)
+  * Added Changes:
+    - debian/usr.sbin.chronyd: ensure RTC/GPS usage isn't blocked by apparmor
+      (LP: #1751241, Closes: #891201)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 26 Feb 2018 14:44:54 +0100
+
 chrony (3.2-4) unstable; urgency=medium
 
   * debian/changelog:
@@ -524,6 +976,27 @@ chrony (3.2-3) unstable; urgency=medium
 
  -- Vincent Blut <vincent.debian@free.fr>  Wed, 07 Feb 2018 21:27:09 +0100
 
+chrony (3.2-2ubuntu3) bionic; urgency=medium
+
+  * Revert the changes of (LP 1746458) as in the follow on discussion
+    it became clear that we want it to start early (for example for an
+    early offset from drift file). iIf needed chrony will later on pick
+    up that servers are online via retries (augmented by hooks on network
+    events).
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 08 Feb 2018 10:52:30 +0100
+
+chrony (3.2-2ubuntu2) bionic; urgency=medium
+
+  * d/control: use to nss instead of tomcrypt (in main) (LP: #1744072)
+  * d/chrony.conf: use ubuntu ntp pool and server (LP: #1744664)
+  * d/chrony.default, d/chrony.service: support /etc/default/chrony
+    DAEMON_OPTS in systemd environment (LP: #1746081)
+  * d/chrony.service: properly start after networking (LP: #1746458)
+  * d/usr.sbin.chronyd: allow to create /run/chrony on demand (LP: #1746444)
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Fri, 19 Jan 2018 09:45:38 +0100
+
 chrony (3.2-2) unstable; urgency=medium
 
   * Initial AppArmor profile for chronyd. Thanks to Jamie
diff -pruN 3.5-9/debian/chrony.conf 3.5-9ubuntu1/debian/chrony.conf
--- 3.5-9/debian/chrony.conf	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/chrony.conf	2020-05-20 07:56:57.000000000 +0000
@@ -1,6 +1,23 @@
 # Welcome to the chrony configuration file. See chrony.conf(5) for more
 # information about usuable directives.
-pool 2.debian.pool.ntp.org iburst
+
+# This will use (up to):
+# - 4 sources from ntp.ubuntu.com which some are ipv6 enabled
+# - 2 sources from 2.ubuntu.pool.ntp.org which is ipv6 enabled as well
+# - 1 source from [01].ubuntu.pool.ntp.org each (ipv4 only atm)
+# This means by default, up to 6 dual-stack and up to 2 additional IPv4-only
+# sources will be used.
+# At the same time it retains some protection against one of the entries being
+# down (compare to just using one of the lines). See (LP: #1754358) for the
+# discussion.
+#
+# About using servers from the NTP Pool Project in general see (LP: #104525).
+# Approved by Ubuntu Technical Board on 2011-02-08.
+# See http://www.pool.ntp.org/join.html for more information.
+pool ntp.ubuntu.com        iburst maxsources 4
+pool 0.ubuntu.pool.ntp.org iburst maxsources 1
+pool 1.ubuntu.pool.ntp.org iburst maxsources 1
+pool 2.ubuntu.pool.ntp.org iburst maxsources 2
 
 # This directive specify the location of the file containing ID/key pairs for
 # NTP authentication.
diff -pruN 3.5-9/debian/chrony.default 3.5-9ubuntu1/debian/chrony.default
--- 3.5-9/debian/chrony.default	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/chrony.default	2020-05-20 07:57:02.000000000 +0000
@@ -4,3 +4,7 @@
 
 # Options to pass to chrony.
 DAEMON_OPTS="-F -1"
+
+# Sync system clock in containers or without CAP_SYS_TIME (likely to fail)
+# See /usr/share/doc/chrony/README.container for details.
+SYNC_IN_CONTAINER="no"
diff -pruN 3.5-9/debian/chronyd-starter.sh 3.5-9ubuntu1/debian/chronyd-starter.sh
--- 3.5-9/debian/chronyd-starter.sh	1970-01-01 00:00:00.000000000 +0000
+++ 3.5-9ubuntu1/debian/chronyd-starter.sh	2020-05-20 07:57:02.000000000 +0000
@@ -0,0 +1,70 @@
+#!/bin/sh
+set -ue
+
+CONF="/etc/default/chrony"
+DOC="/usr/share/doc/chrony/README.container"
+CAP="cap_sys_time"
+CMD="/usr/sbin/chronyd"
+# Take any args passed, use none if nothing was specified
+EFFECTIVE_DAEMON_OPTS=${@:-""}
+
+if [ -f "${CONF}" ]; then
+    . "${CONF}"
+else
+    echo "<4>Warning: ${CONF} is missing"
+fi
+# take from conffile if available, default to no otherwise
+EFFECTIVE_SYNC_IN_CONTAINER=${SYNC_IN_CONTAINER:-"no"}
+
+if [ ! -x "${CMD}" ]; then
+    echo "<3>Error: ${CMD} not executable"
+    # ugly, but works around https://github.com/systemd/systemd/issues/2913
+    sleep 0.1
+    exit 1
+fi
+
+# Check if -x is already set manually, don't process further if that is the case
+X_SET=0
+while getopts ":x" opt; do
+    case $opt in
+        x)
+            X_SET=1
+            ;;
+    esac
+done
+
+if [ ${X_SET} -ne 1 ]; then
+  # Assume it is not in a container
+  IS_CONTAINER=0
+  if [ -x /usr/bin/systemd-detect-virt ]; then
+      if /usr/bin/systemd-detect-virt --quiet --container; then
+          IS_CONTAINER=1
+      fi
+  fi
+
+
+  # Assume it has the cap
+  HAS_CAP=1
+  CAPSH="/sbin/capsh"
+  if [ -x "${CAPSH}" ]; then
+      ${CAPSH} --has-p="${CAP}" || HAS_CAP=0
+  fi
+
+  if [ ${HAS_CAP} -eq 0 ]; then
+      echo "<4>Warning: Missing ${CAP}, syncing the system clock will fail"
+  fi
+  if [ ${IS_CONTAINER} -eq 1 ]; then
+      echo "<4>Warning: Running in a container, likely impossible and unintended to sync system clock"
+  fi
+
+  if [ ${HAS_CAP} -eq 0 -o ${IS_CONTAINER} -eq 1 ]; then
+      if [ "${EFFECTIVE_SYNC_IN_CONTAINER}" != "yes" ]; then
+          echo "<5>Adding -x as fallback disabling control of the system clock, see ${DOC} to override this behavior"
+          EFFECTIVE_DAEMON_OPTS="${EFFECTIVE_DAEMON_OPTS} -x"
+      else
+          echo "<5>Not falling back to disable control of the system clock, see ${DOC} to change this behavior"
+      fi
+  fi
+fi
+
+${CMD} ${EFFECTIVE_DAEMON_OPTS}
diff -pruN 3.5-9/debian/chrony.service 3.5-9ubuntu1/debian/chrony.service
--- 3.5-9/debian/chrony.service	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/chrony.service	2020-05-20 07:57:02.000000000 +0000
@@ -5,13 +5,13 @@ Conflicts=openntpd.service ntp.service n
 Wants=time-sync.target
 Before=time-sync.target
 After=network.target
-ConditionCapability=CAP_SYS_TIME
 
 [Service]
 Type=forking
 PIDFile=/run/chronyd.pid
 EnvironmentFile=-/etc/default/chrony
-ExecStart=/usr/sbin/chronyd $DAEMON_OPTS
+# Starter takes care of special cases mostly for containers
+ExecStart=/usr/lib/systemd/scripts/chronyd-starter.sh $DAEMON_OPTS
 ExecStartPost=-/usr/lib/chrony/chrony-helper update-daemon
 PrivateTmp=yes
 ProtectHome=yes
diff -pruN 3.5-9/debian/control 3.5-9ubuntu1/debian/control
--- 3.5-9/debian/control	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/control	2020-05-20 07:57:39.000000000 +0000
@@ -1,7 +1,8 @@
 Source: chrony
 Section: net
 Priority: optional
-Maintainer: Vincent Blut <vincent.debian@free.fr>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Vincent Blut <vincent.debian@free.fr>
 Uploaders: Joachim Wiedorn <joodebian@joonet.de>
 Standards-Version: 4.5.0
 Build-Depends: asciidoctor (>= 1.5.3-1~),
@@ -26,6 +27,7 @@ Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser,
          iproute2 [linux-any],
+         libcap2-bin (>= 1:2.32-1),
          ucf,
          ${misc:Depends},
          ${shlibs:Depends}
diff -pruN 3.5-9/debian/docs 3.5-9ubuntu1/debian/docs
--- 3.5-9/debian/docs	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/docs	2020-05-20 07:57:03.000000000 +0000
@@ -1,3 +1,4 @@
 FAQ
 NEWS
 README
+debian/README.container
diff -pruN 3.5-9/debian/install 3.5-9ubuntu1/debian/install
--- 3.5-9/debian/install	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/install	2020-05-20 07:57:02.000000000 +0000
@@ -3,3 +3,4 @@ debian/chrony-helper usr/lib/chrony
 debian/chrony.conf usr/share/chrony
 debian/ntp-units.d/50-chrony.list usr/lib/systemd/ntp-units.d
 debian/usr.sbin.chronyd etc/apparmor.d
+debian/chronyd-starter.sh usr/lib/systemd/scripts/
diff -pruN 3.5-9/debian/README.container 3.5-9ubuntu1/debian/README.container
--- 3.5-9/debian/README.container	1970-01-01 00:00:00.000000000 +0000
+++ 3.5-9ubuntu1/debian/README.container	2020-05-20 07:57:39.000000000 +0000
@@ -0,0 +1,60 @@
+Chrony in Containers
+--------------------
+
+Currently in 99.9+% of the cases syncing the local clock in a container
+is wrong. Most of the time it will be unable to do so, because it is lacking
+CAP_SYS_TIME. Or worse, if the CAP_SYS_TIME privilege is granted, multiple
+containers could fight over the system's time, because the Linux kernel does
+not provide time namespaces (yet).
+
+There are two things a user installing chrony usually wants:
+1. synchronize my time (NTP client)
+2. serve NTP (NTP server)
+
+In a container the first makes (usually) no sense, so by default we enable -x
+there (as it would only crash otherwise).
+This will disable the control of the system clock.
+See `man chronyd` for more details on the -x option.
+
+Formerly, the check for Condition=CAP_SYS_TIME in the systemd service avoided
+the crash of the NTP client portion, but that means the server use case will
+not work by default in containers. It is still not recommended to use a
+container as an NTP server, but if the host clock is synchronised via NTP,
+adding the -x option to chronyd instances running in containers will allow
+them to function as NTP servers which do not adjust the system clock.
+The Condition=CAP_SYS_TIME check was a silent, no-log-entry stealing away
+leaving users often unclear what happened - especially if they were more after
+the NTP server than the NTP client.
+
+One could argue that someone who installs chrony expects the system time to be
+synchronised, so it should fail if it is not able to do so.  On the other hand
+it could be argued that someone who installs chrony expects time to be served
+over the network via NTP.
+We can't know which expectation is applicable, so we assume that time should
+be synchronised unless chronyd is running in a container (or is without
+CAP_SYS_TIME in any other environment).
+
+To make things worse recent container implementations will offer CAP_SYS_TIME
+to the container. Since from the container's point of view, this capability is
+available for the container's user namespace. Just later on adjtimex and similar
+are actually evaluated against the host kernel where they will fail. Due to
+that without further precaution running chrony in Ubuntu in the future will
+likely have the service start (as Condition=CAP_SYS_TIME will be true) but
+then immediately fail.
+This will depend on the environment e.g. versions and types of containers and
+thereby feel just 'unreliable' from users point of view.
+Furthermore it will affect upgrades as the service has to be restarted for a
+package upgrade to be considered complete.
+
+Due to all of that Ubuntu decided (LP: #1589780) to default to -x (do not
+set the system clock) in containers.
+
+If one really wants to (try to) sync time in a container or CAP_SYS_TIME-less
+environment set SYNC_IN_CONTAINER="yes" in /etc/default/chrony to disable
+this special handling.
+
+It is important to mention that as soon as upstream provides a way to provide
+a default config working in those cases Ubuntu intends to use that and drop
+the current workaround.
+
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Fri, 16 Mar 2018 12:25:44 +0100
diff -pruN 3.5-9/debian/tests/control 3.5-9ubuntu1/debian/tests/control
--- 3.5-9/debian/tests/control	2020-05-19 14:42:18.000000000 +0000
+++ 3.5-9ubuntu1/debian/tests/control	2020-05-20 07:57:39.000000000 +0000
@@ -4,7 +4,8 @@ Restrictions: isolation-container, build
 
 Tests: time-sources-from-dhcp-servers
 Depends: @, isc-dhcp-server, isc-dhcp-client, iproute2, kmod
-Restrictions: isolation-machine, needs-root
+# allow-stderr is needed until systemd fixed LP: 1873031
+Restrictions: isolation-machine, needs-root, allow-stderr
 
 Features: test-name=run_system_tests
 Test-Command: debian/tests/upstream-system-tests
